const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const formaDePagamento = require('../../../page-objects/parametrizacao/financeiro/formaDePagamento.po');
describe('Forma de Pagamento', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        formaDePagamento.abrir();
    });

    afterEach(() => {
        geral.sair();
    });
    it('Acessar tela de Forma de Pagamento', () => {
        expect(z.component.header.getTitle()).toBe('Forma de Pagamento');
    });
    it('Realizar o preenchimento dos campos solicitados na página', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-15868943374170126843228')));
        geral.clickAdicionar();
        formaDePagamento.adicionar(j.getValor('codigoFormaDePagamento'), j.getValor('nomeFormaDePagamento'),
            j.getValor('dataReferencia'), j.getValor('intervaloDataReferencia'), j.getValor('considerarDiasUteis'),
            j.getValor('periodo'));
        geral.clickSalvar();
        geral.filterIt(j.getValor('nomeFormaDePagamento'));
        expect(geral.gridHasText('15868943374170126843228', j.getValor('nomeFormaDePagamento'), 1)).toBe(j.getValor('nomeFormaDePagamento'));
    });
    it('Editar Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-15868943374170126843228')));
        geral.filterIt(j.getValor('nomeFormaDePagamento'));
        geral.clickGrid('NMFORMPGTO', j.getValor('nomeFormaDePagamento'), '15868943374170126843228');
        geral.clickEditar();
        formaDePagamento.editar(j.getValor('nomeFormaDePagamento1'), j.getValor('dataReferencia1'),
        j.getValor('intervaloDataReferencia1'), j.getValor('considerarDiasUteis1'), j.getValor('periodo1'));
        geral.clickSalvar();
        geral.clickVoltar();
        geral.filterIt(j.getValor('nomeFormaDePagamento1'));
        expect(geral.gridHasText('15868943374170126843228', j.getValor('nomeFormaDePagamento1'), 1)).toBe(j.getValor('nomeFormaDePagamento1'));
    });
    it('Excluir Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-15868943374170126843228')));
        geral.filterIt(j.getValor('nomeFormaDePagamento1'));
        geral.clickGrid('NMFORMPGTO', j.getValor('nomeFormaDePagamento1'), '15868943374170126843228');
        geral.clickExcluir();
        geral.clickSim();
        geral.filterIt(j.getValor('nomeFormaDePagamento1'));
        expect(geral.gridHasText('15868943374170126843228', j.getValor('nomeFormaDePagamento1'), 1)).toBeUndefined();
    }
    );
});
